import Flutter
import UIKit
import AppCenter
import AppCenterAnalytics
import AppCenterCrashes

public class SwiftMicrosoftAppcenterFlutterPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "microsoft_appcenter_flutter", binaryMessenger: registrar.messenger())
    let instance = SwiftMicrosoftAppcenterFlutterPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
        /// AppCenter
    case "start":
        guard let args:[String: Any] = (call.arguments as? [String: Any]) else { return }

        let secret = args["appSecret"] as! String
        //let services = args["service"] as! [String]
        
        /*var serviceClasses: [AnyClass] = []
        if services.contains("Analytics") {
            serviceClasses.append(Analytics.self)
        }
        if services.contains("Crashes") {
            serviceClasses.append(Crashes.self)
        }*/
        
        AppCenter.start(withAppSecret: secret, services: [Analytics.self])
        result(nil)
    case "installId":
        result(AppCenter.installId.uuidString)
    case "isEnabled":
        result(AppCenter.enabled)
    case "setEnabled":
        guard let args:[String: Any] = (call.arguments as? [String: Any]) else { return }
        let enabled = args["isEnabled"] as! Bool
        AppCenter.enabled = enabled
        result(nil)
        
        /// Crashes
    case "isEnabledCrashes":
        result(Crashes.enabled)
    case "setEnabledCrashes":
        guard let args:[String: Any] = (call.arguments as? [String: Any]) else { return }
        let enabled = args["isEnabled"] as! Bool
        Crashes.enabled = enabled
        result(nil)
    case "generateTestCrash":
        Crashes.generateTestCrash()
        result(nil)
        
        /// Analytics
    case "isEnabledAnalytics":
        result(Analytics.enabled)
    case "setEnabledAnalytics":
        guard let args:[String: Any] = (call.arguments as? [String: Any]) else { return }
        let enabled = args["isEnabled"] as! Bool
        Analytics.enabled = enabled
        result(nil)
    case "trackEvent":
        guard let args:[String: Any] = (call.arguments as? [String: Any]) else { return }
        let name = args["name"] as? String
        let properties = args["properties"] as? [String: String]
        if(name != nil) {
            Analytics.trackEvent(name!, withProperties: properties)
        }
        result(nil)
    default:
        result(FlutterMethodNotImplemented);
    }
  }
}
