import 'dart:async';
import 'package:flutter/services.dart';

class AppCenter {
  static const MethodChannel _channel =
  const MethodChannel('microsoft_appcenter_flutter');

  /// Starts App Center services
  static Future<String> start(String appSecret, List<String> services) {
    return _channel.invokeMethod('start', <String, dynamic>{
      'appSecret': appSecret,
      'services': services
    }).then((r) => r as String);
  }

  static Future<String> get installId =>
      _channel.invokeMethod('installId').then((r) => r as String);

  static Future<bool> get isEnabled => _channel.invokeMethod('isEnabled');

  static Future setEnabled(bool isEnabled) =>
      _channel.invokeMethod('setEnabled', <String, bool>{
        'isEnabled': isEnabled,
      });
}