import 'dart:async';
import 'package:flutter/services.dart';
import 'package:flutter/foundation.dart' show defaultTargetPlatform;
import 'package:flutter/foundation.dart' show TargetPlatform;

class AppCenterAnalytics {
  static const MethodChannel _channel =
  const MethodChannel('microsoft_appcenter_flutter');

  static String get id => (defaultTargetPlatform == TargetPlatform.iOS)
      ? "Analytics"
      : "com.microsoft.appcenter.analytics.Analytics";

  static Future<bool> get isEnabledAnalytics =>
      _channel.invokeMethod('isEnabledAnalytics').then((r) => r as bool);

  static Future setEnabledAnalytics(bool isEnabled) =>
      _channel.invokeMethod('setEnabledAnalytics', <String, bool>{
        'isEnabled': isEnabled,
      });

  static Future trackEvent(String name, [Map<String, String> properties]) =>
      _channel.invokeMethod('trackEvent', <String, dynamic>{
        'name': name,
        'properties': properties ?? <String, String>{},
      });
}