import 'dart:async';
import 'package:flutter/services.dart';
import 'package:flutter/foundation.dart' show defaultTargetPlatform;
import 'package:flutter/foundation.dart' show TargetPlatform;

class AppCenterCrashes{
  static const MethodChannel _channel =
  const MethodChannel('microsoft_appcenter_flutter');

  static String get id => (defaultTargetPlatform == TargetPlatform.iOS)
      ? "Crashes"
      : "com.microsoft.appcenter.crashes.Crashes";

  static Future<bool> get isEnabledCrashes async =>
      _channel.invokeMethod('isEnabledCrashes').then((r) => r as bool);

  static Future setEnabled(bool isEnabled) =>
      _channel.invokeMethod('setEnabledCrashes', <String, bool>{
        'isEnabled': isEnabled,
      });

  static Future generateTestCrash() =>
      _channel.invokeMethod('generateTestCrash');
}